//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  OrangeRed
#property indicator_color2  Gold
#property indicator_width1  2
#property indicator_style2  STYLE_DOT

//
//
//
//
//

extern int TrixPeriod   = 14;
extern int TrixPrice    = PRICE_CLOSE;
extern int SignalPeriod = 9;
extern int SignalMode   = MODE_EMA;
double Trix[];
double Sign[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,Trix);
   SetIndexBuffer(1,Sign);
   IndicatorShortName("Trix ("+TrixPeriod+","+SignalPeriod+")");
   return(0);
}

//
//
//
//
//

double workTrix[][3];
int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(workTrix,0)!=Bars) ArrayResize(workTrix,Bars);

   //
   //
   //
   //
   //

   double alpha = 2.0/(1.0+TrixPeriod);
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         double price = MathLog(iMA(NULL,0,1,0,MODE_SMA,TrixPrice,i));
            workTrix[r][0] =  workTrix[r-1][0]+alpha*(price         -workTrix[r-1][0]);
            workTrix[r][1] =  workTrix[r-1][1]+alpha*(workTrix[r][0]-workTrix[r-1][1]);
            workTrix[r][2] =  workTrix[r-1][2]+alpha*(workTrix[r][1]-workTrix[r-1][2]);
         
            if (workTrix[r-1][2]!=0)
                 Trix[i] = (workTrix[r][2]-workTrix[r-1][2])/workTrix[r-1][2];
            else Trix[i] = 0.00;
      }   
      for (i=limit; i>=0; i--) Sign[i] = iMAOnArray(Trix,0,SignalPeriod,0,SignalMode,i);
   return(0);
}